/* Generated automatically by the program `genattrtab'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "options.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-attr.h"
#include "memmodel.h"
#include "tm_p.h"
#include "insn-config.h"
#include "recog.h"
#include "regs.h"
#include "real.h"
#include "output.h"
#include "toplev.h"
#include "flags.h"
#include "emit-rtl.h"

#define operands recog_data.operand

int
insn_default_latency (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  enum attr_tune_arc700 cached_tune_arc700 ATTRIBUTE_UNUSED;
  enum attr_type cached_type ATTRIBUTE_UNUSED;

  switch (recog_memoized (insn))
    {
    case 443:  /* vld32_insn */
    case 442:  /* vld64_insn */
    case 441:  /* vld64w_insn */
    case 440:  /* vld32wl_insn */
    case 439:  /* vld32wh_insn */
    case 415:  /* vmovw_insn */
    case 413:  /* vd6tapf_insn */
    case 411:  /* vmvw_insn */
      return 5;

    case 430:  /* vupsbw_insn */
    case 428:  /* vupbw_insn */
    case 426:  /* vexch4_insn */
    case 425:  /* vexch2_insn */
    case 424:  /* vexch1_insn */
    case 417:  /* vsr8_insn */
    case 409:  /* vsr8i_insn */
    case 407:  /* vasrrpwbi_insn */
    case 406:  /* vasrpwbi_insn */
    case 404:  /* vasrsrwi_insn */
    case 403:  /* vasrrwi_insn */
    case 400:  /* vbmulw_insn */
    case 399:  /* vbmulfw_insn */
    case 389:  /* vmrb_insn */
    case 388:  /* vmr7w_insn */
    case 386:  /* vmr6w_insn */
    case 384:  /* vmr5w_insn */
    case 382:  /* vmr4w_insn */
    case 380:  /* vmr3w_insn */
    case 378:  /* vmr2w_insn */
    case 376:  /* vmr1w_insn */
    case 363:  /* vsummw_insn */
    case 360:  /* vmulw_insn */
    case 359:  /* vmulfw_insn */
      return 3;

    case 423:  /* vsignw_insn */
    case 422:  /* vaddsuw_insn */
    case 421:  /* vabsw_insn */
    case 418:  /* vasrw_insn */
    case 416:  /* vmovzw_insn */
    case 412:  /* vmvzw_insn */
    case 405:  /* vasrwi_insn */
    case 402:  /* vbsubw_insn */
    case 401:  /* vbrsubw_insn */
    case 397:  /* vbminw_insn */
    case 396:  /* vbmaxw_insn */
    case 395:  /* vbaddw_insn */
    case 374:  /* vnew_insn */
    case 373:  /* vltw_insn */
    case 372:  /* vlew_insn */
    case 371:  /* veqw_insn */
    case 369:  /* vxor_insn */
    case 368:  /* vor_insn */
    case 366:  /* vbic_insn */
    case 364:  /* vand_insn */
    case 362:  /* vsubw_insn */
    case 356:  /* vminw_insn */
    case 354:  /* vmaxw_insn */
    case 352:  /* vdifw_insn */
    case 350:  /* vavrb_insn */
    case 349:  /* vavb_insn */
    case 348:  /* vaddw_insn */
      return 2;

    case 346:  /* movti_insn */
    case 345:  /* movv8hi_insn */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 1)
        {
	  return 1;
        }
      else if (!((1ULL << which_alternative) & 0x3ULL))
        {
	  return 2;
        }
      else
        {
	  return 4;
        }

    case 446:  /* vinti_insn */
    case 445:  /* vst32_n_insn */
    case 444:  /* vst16_n_insn */
    case 438:  /* vendrec_insn */
    case 437:  /* vrecrun_insn */
    case 436:  /* vrun_insn */
    case 435:  /* vrec_insn */
    case 434:  /* vdowr_insn */
    case 433:  /* vdiwr_insn */
    case 432:  /* vdorun_insn */
    case 431:  /* vdirun_insn */
    case 344:  /* vst64_insn */
    case 343:  /* vst128_insn */
      return 1;

    case 429:  /* vupsbaw_insn */
    case 427:  /* vupbaw_insn */
    case 420:  /* vabsaw_insn */
    case 419:  /* vsr8aw_insn */
    case 414:  /* vmovaw_insn */
    case 410:  /* vmvaw_insn */
    case 408:  /* vsr8awi_insn */
    case 398:  /* vbmulaw_insn */
    case 394:  /* vvc1ft_insn */
    case 393:  /* vvc1f_insn */
    case 392:  /* vh264fw_insn */
    case 391:  /* vh264ft_insn */
    case 390:  /* vh264f_insn */
    case 387:  /* vmr7aw_insn */
    case 385:  /* vmr6aw_insn */
    case 383:  /* vmr5aw_insn */
    case 381:  /* vmr4aw_insn */
    case 379:  /* vmr3aw_insn */
    case 377:  /* vmr2aw_insn */
    case 375:  /* vmr1aw_insn */
    case 370:  /* vxoraw_insn */
    case 367:  /* vbicaw_insn */
    case 365:  /* vandaw_insn */
    case 361:  /* vsubaw_insn */
    case 358:  /* vmulfaw_insn */
    case 357:  /* vmulaw_insn */
    case 355:  /* vminaw_insn */
    case 353:  /* vmaxaw_insn */
    case 351:  /* vdifaw_insn */
    case 347:  /* vaddaw_insn */
    case 342:  /* vld128_insn */
      return 4;

    case 740:  /* *p divdf3 */
    case 320:  /* sqrtdf2 */
    case 319:  /* divdf3 */
      extract_constrain_insn_cached (insn);
      if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))))
        {
	  return 34 /* 0x22 */;
        }
      else
        {
	  return 0;
        }

    case 734:  /* *p *divsf3_fpu */
    case 312:  /* sqrtsf2_fpu */
    case 311:  /* *divsf3_fpu */
      extract_constrain_insn_cached (insn);
      if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))))
        {
	  return 20 /* 0x14 */;
        }
      else
        {
	  return 0;
        }

    case 733:  /* *p fnmadf4_fpu */
    case 732:  /* *p fmadf4_fpu */
    case 731:  /* *p fnmasf4_fpu */
    case 730:  /* *p fmasf4_fpu */
    case 310:  /* fnmadf4_fpu */
    case 309:  /* fmadf4_fpu */
    case 306:  /* fnmasf4_fpu */
    case 305:  /* fmasf4_fpu */
      extract_constrain_insn_cached (insn);
      if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))))
        {
	  return 12 /* 0xc */;
        }
      else
        {
	  return 0;
        }

    case 760:  /* *p fix_truncdfsi2 */
    case 759:  /* *p fixuns_truncdfsi2 */
    case 758:  /* *p floatunsdisf2 */
    case 757:  /* *p floatdisf2 */
    case 756:  /* *p truncdfsf2 */
    case 755:  /* *p fix_truncdfdi2 */
    case 754:  /* *p fixuns_truncdfdi2 */
    case 753:  /* *p floatunsdidf2 */
    case 752:  /* *p floatdidf2 */
    case 751:  /* *p fix_truncsfsi2_fpu */
    case 750:  /* *p fixuns_truncsfsi2 */
    case 749:  /* *p floatunssisf2 */
    case 748:  /* *p floatsisf2_fpu */
    case 747:  /* *p fix_truncsfdi2 */
    case 746:  /* *p fixuns_truncsfdi2 */
    case 745:  /* *p floatunssidf2 */
    case 744:  /* *p floatsidf2 */
    case 743:  /* *p extendsfdf2 */
    case 742:  /* *p *cmpdf_fpu_trap */
    case 741:  /* *p *cmpdf_fpu */
    case 739:  /* *p *muldf3_fpu */
    case 738:  /* *p *subdf3_fpu */
    case 737:  /* *p *adddf3_fpu */
    case 736:  /* *p *cmpsf_fpu_trap */
    case 735:  /* *p *cmpsf_fpu */
    case 729:  /* *p *mulsf3_fpu */
    case 728:  /* *p *subsf3_fpu */
    case 727:  /* *p *addsf3_fpu */
    case 341:  /* fix_truncdfsi2 */
    case 340:  /* fixuns_truncdfsi2 */
    case 339:  /* floatunsdisf2 */
    case 338:  /* floatdisf2 */
    case 337:  /* truncdfsf2 */
    case 336:  /* fix_truncdfdi2 */
    case 335:  /* fixuns_truncdfdi2 */
    case 334:  /* floatunsdidf2 */
    case 333:  /* floatdidf2 */
    case 332:  /* fix_truncsfsi2_fpu */
    case 331:  /* fixuns_truncsfsi2 */
    case 330:  /* floatunssisf2 */
    case 329:  /* floatsisf2_fpu */
    case 328:  /* fix_truncsfdi2 */
    case 327:  /* fixuns_truncsfdi2 */
    case 326:  /* floatunssidf2 */
    case 325:  /* floatsidf2 */
    case 324:  /* extendsfdf2 */
    case 323:  /* *cmpdf_fpu_uneq */
    case 322:  /* *cmpdf_fpu_trap */
    case 321:  /* *cmpdf_fpu */
    case 318:  /* *muldf3_fpu */
    case 317:  /* *subdf3_fpu */
    case 316:  /* *adddf3_fpu */
    case 315:  /* *cmpsf_fpu_uneq */
    case 314:  /* *cmpsf_fpu_trap */
    case 313:  /* *cmpsf_fpu */
    case 304:  /* *mulsf3_fpu */
    case 303:  /* *subsf3_fpu */
    case 302:  /* *addsf3_fpu */
      extract_constrain_insn_cached (insn);
      if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))))
        {
	  return 8;
        }
      else
        {
	  return 0;
        }

    case 291:  /* *dmulh_peep2_insn */
    case 288:  /* muldf3_insn */
      extract_constrain_insn_cached (insn);
      if (
#line 37 "../../gcc-13.2.1-20230728/gcc/config/arc/fpx.md"
(TARGET_DPFP_COMPACT_SET))
        {
	  return 7;
        }
      else if (
#line 47 "../../gcc-13.2.1-20230728/gcc/config/arc/fpx.md"
(TARGET_DPFP_FAST_SET))
        {
	  return 5;
        }
      else
        {
	  return 0;
        }

    case 292:  /* *dsubh_peep2_insn */
    case 290:  /* *daddh_peep2_insn */
    case 289:  /* subdf3_insn */
    case 287:  /* adddf3_insn */
    case 279:  /* cmpdfpx_raw */
      extract_constrain_insn_cached (insn);
      if ((
#line 37 "../../gcc-13.2.1-20230728/gcc/config/arc/fpx.md"
(TARGET_DPFP_COMPACT_SET)) || (
#line 47 "../../gcc-13.2.1-20230728/gcc/config/arc/fpx.md"
(TARGET_DPFP_FAST_SET)))
        {
	  return 5;
        }
      else
        {
	  return 0;
        }

    case 278:  /* cmpsfpx_raw */
    case 277:  /* *mulsf3_fpx */
    case 276:  /* *subsf3_fpx */
    case 275:  /* *addsf3_fpx */
      extract_constrain_insn_cached (insn);
      if (
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/fpx.md"
(TARGET_SPFP_COMPACT_SET))
        {
	  return 3;
        }
      else if (
#line 32 "../../gcc-13.2.1-20230728/gcc/config/arc/fpx.md"
(TARGET_SPFP_FAST_SET))
        {
	  return 6;
        }
      else
        {
	  return 0;
        }

    case 156:  /* divaw */
      if (get_attr_tune_arc700 (insn) == TUNE_ARC700_TRUE)
        {
	  return 2;
        }
      else
        {
	  return 0;
        }

    case 186:  /* arc_lp */
    case 183:  /* p_return_i */
    case 182:  /* arc600_rtie */
    case 181:  /* simple_return */
    case 159:  /* rtie */
    case 147:  /* blockage */
      return 0;

    case 696:  /* *p *cmpdf_ord */
    case 695:  /* *p *cmpdf_uneq */
    case 694:  /* *p *cmpdf_ge */
    case 693:  /* *p *cmpdf_gt */
    case 692:  /* *p *cmpdf_eq */
    case 691:  /* *p *cmpsf_ord */
    case 690:  /* *p *cmpsf_uneq */
    case 689:  /* *p *cmpsf_ge */
    case 688:  /* *p *cmpsf_gt */
    case 687:  /* *p *cmpsf_eq */
    case 685:  /* *p *sibcall_value_insn */
    case 684:  /* *p *sibcall_insn */
    case 682:  /* *p *call_value_i */
    case 681:  /* *p *call_i */
    case 273:  /* *pop_multi_fp_blink_ret */
    case 272:  /* *pop_multi_fp_ret */
    case 271:  /* *pop_multi_fp_blink */
    case 270:  /* *pop_multi_fp */
    case 269:  /* *push_multi_fp_blink */
    case 268:  /* *push_multi_fp */
    case 204:  /* *millicode_sibthunk_ld */
    case 203:  /* *millicode_thunk_ld */
    case 202:  /* *millicode_thunk_st */
    case 199:  /* *cmpdf_ord */
    case 198:  /* *cmpdf_uneq */
    case 197:  /* *cmpdf_ge */
    case 196:  /* *cmpdf_gt */
    case 195:  /* *cmpdf_eq */
    case 194:  /* *cmpsf_ord */
    case 193:  /* *cmpsf_uneq */
    case 192:  /* *cmpsf_ge */
    case 191:  /* *cmpsf_gt */
    case 190:  /* *cmpsf_eq */
    case 189:  /* dbnz */
    case 187:  /* loop_end */
    case 185:  /* *bbit */
    case 184:  /* cbranchsi4_scratch */
    case 180:  /* *sibcall_value_insn */
    case 179:  /* *sibcall_insn */
    case 143:  /* *call_value_i */
    case 142:  /* *call_i */
    case 141:  /* casesi_jump */
    case 139:  /* casesi_dispatch */
    case 138:  /* indirect_jump */
    case 137:  /* jump_i */
    case 136:  /* *rev_branch_insn */
    case 135:  /* *branch_insn */
      extract_constrain_insn_cached (insn);
      if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))))
        {
	  return 1;
        }
      else
        {
	  return 0;
        }

    case 657:  /* *p umac64_600 */
    case 653:  /* *p mac64_600 */
    case 652:  /* *p mul64_600 */
    case 646:  /* *p mac_600 */
    case 92:  /* umac64_600 */
    case 91:  /* umul64_600 */
    case 85:  /* mac64_600 */
    case 84:  /* mul64_600 */
    case 74:  /* mac_600 */
    case 73:  /* umul_600 */
      if ((
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600)))
        {
	  return 3;
        }
      else
        {
	  return 0;
        }

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      extract_constrain_insn_cached (insn);
      if (((
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && ((cached_type = get_attr_type (insn)) == TYPE_COMPARE))
        {
	  return 3;
        }
      else if (((
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD) && (GET_MODE (operands[0]) == DImode))
        {
	  return 4;
        }
      else if (((
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD) && (! (GET_MODE (operands[0]) == DImode)))
        {
	  return 3;
        }
      else if (((
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (
#line 48 "../../gcc-13.2.1-20230728/gcc/config/arc/arc600.md"
(arc_multcost < COSTS_N_INSNS (7))) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 3;
        }
      else if (((
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (
#line 54 "../../gcc-13.2.1-20230728/gcc/config/arc/arc600.md"
(arc_multcost >= COSTS_N_INSNS (7))) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 8;
        }
      else if (((
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && ((cached_type = get_attr_type (insn)) == TYPE_MULMAC_600))
        {
	  return 3;
        }
      else if (((cached_tune_arc700 = get_attr_tune_arc700 (insn)) == TUNE_ARC700_TRUE) && (((cached_type = get_attr_type (insn)) == TYPE_UNARY) || (cached_type == TYPE_MOVE) || (cached_type == TYPE_CMOVE) || (cached_type == TYPE_BINARY)) && (GET_MODE (operands[0]) == DImode))
        {
	  return 2;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_LR))
        {
	  return 2;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_SR))
        {
	  return 1;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && (((cached_type = get_attr_type (insn)) == TYPE_UNARY) || (cached_type == TYPE_MOVE) || (cached_type == TYPE_BINARY)))
        {
	  return 1;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_CMOVE))
        {
	  return 1;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_CC_ARITH))
        {
	  return 1;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_TWO_CYCLE_CORE))
        {
	  return 2;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_DIVAW))
        {
	  return 2;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_SHIFT))
        {
	  return 2;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_COMPARE))
        {
	  return 3;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_COMPARE))
        {
	  return 1;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_MULTI) && (GET_MODE (operands[0]) == DImode))
        {
	  return 10 /* 0xa */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_UMULTI) && (GET_MODE (operands[0]) == DImode))
        {
	  return 9;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_UMULTI))
        {
	  return 5;
        }
      else if ((((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC)))) && ((cached_type = get_attr_type (insn)) == TYPE_MULTI))
        {
	  return 5;
        }
      else if ((((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD)))) && ((cached_type = get_attr_type (insn)) == TYPE_MULTI))
        {
	  return 7;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD))
        {
	  return 3;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_STORE))
        {
	  return 1;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcEM.md"
(TARGET_EM)) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD))
        {
	  return 2;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcEM.md"
(TARGET_EM)) && ((cached_type = get_attr_type (insn)) == TYPE_STORE))
        {
	  return 1;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 39 "../../gcc-13.2.1-20230728/gcc/config/arc/arcEM.md"
(arc_mpy_option > 0)) && (
#line 40 "../../gcc-13.2.1-20230728/gcc/config/arc/arcEM.md"
(arc_mpy_option <= 2)) && ((cached_type = get_attr_type (insn)) == TYPE_MUL16_EM))
        {
	  return 1;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 46 "../../gcc-13.2.1-20230728/gcc/config/arc/arcEM.md"
(arc_mpy_option > 2)) && (
#line 47 "../../gcc-13.2.1-20230728/gcc/config/arc/arcEM.md"
(arc_mpy_option <= 5)) && ((cached_type = get_attr_type (insn)) == TYPE_MUL16_EM))
        {
	  return 2;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 53 "../../gcc-13.2.1-20230728/gcc/config/arc/arcEM.md"
(arc_mpy_option == 6)) && ((cached_type = get_attr_type (insn)) == TYPE_MUL16_EM))
        {
	  return 4;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 59 "../../gcc-13.2.1-20230728/gcc/config/arc/arcEM.md"
(arc_mpy_option == 2)) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 1;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 65 "../../gcc-13.2.1-20230728/gcc/config/arc/arcEM.md"
(arc_mpy_option == 3)) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 2;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 71 "../../gcc-13.2.1-20230728/gcc/config/arc/arcEM.md"
(arc_mpy_option == 4)) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 3;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 78 "../../gcc-13.2.1-20230728/gcc/config/arc/arcEM.md"
(arc_mpy_option == 5)) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 4;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 53 "../../gcc-13.2.1-20230728/gcc/config/arc/arcEM.md"
(arc_mpy_option == 6)) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 9;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 91 "../../gcc-13.2.1-20230728/gcc/config/arc/arcEM.md"
(TARGET_DIVREM)) && ((cached_type = get_attr_type (insn)) == TYPE_DIV_REM))
        {
	  return 3;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && (! (
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD))) && (! (
#line 662 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW))))) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD))
        {
	  return 4;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && (! (
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD))) && (! (
#line 662 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW))))) && ((cached_type = get_attr_type (insn)) == TYPE_STORE))
        {
	  return 1;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && (! (
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD))) && (! (
#line 662 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW))))) && (((cached_type = get_attr_type (insn)) == TYPE_CC_ARITH) || (cached_type == TYPE_TWO_CYCLE_CORE) || (cached_type == TYPE_SHIFT) || (cached_type == TYPE_LR) || (cached_type == TYPE_SR)))
        {
	  return 4;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && (! (
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD))) && (! (
#line 662 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW))))) && (((cached_type = get_attr_type (insn)) == TYPE_MOVE) || (cached_type == TYPE_CMOVE) || (cached_type == TYPE_UNARY) || (cached_type == TYPE_BINARY) || (cached_type == TYPE_COMPARE) || (cached_type == TYPE_MISC)))
        {
	  return 4;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (
#line 91 "../../gcc-13.2.1-20230728/gcc/config/arc/arcEM.md"
(TARGET_DIVREM)) && (((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && (! (
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD))) && (! (
#line 662 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW))))) && ((cached_type = get_attr_type (insn)) == TYPE_DIV_REM))
        {
	  return 13 /* 0xd */;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && (! (
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD))) && (! (
#line 662 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW))))) && (((cached_type = get_attr_type (insn)) == TYPE_MUL16_EM) || (cached_type == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 4;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))) && (((cached_type = get_attr_type (insn)) == TYPE_CALL) || (cached_type == TYPE_CALL_NO_DELAY_SLOT) || (cached_type == TYPE_UNCOND_BRANCH) || (cached_type == TYPE_JUMP) || (cached_type == TYPE_BRANCH) || (cached_type == TYPE_SFUNC)))
        {
	  return 1;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))) && (((cached_type = get_attr_type (insn)) == TYPE_BRCC) || (cached_type == TYPE_BRCC_NO_DELAY_SLOT) || (cached_type == TYPE_LOOP_END)))
        {
	  return 1;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD))
        {
	  return 4;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)))) && ((cached_type = get_attr_type (insn)) == TYPE_STORE))
        {
	  return 1;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)))) && (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A)))) && ((cached_type = get_attr_type (insn)) == TYPE_STORE))
        {
	  return 2;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))) && (((cached_type = get_attr_type (insn)) == TYPE_CC_ARITH) || (cached_type == TYPE_TWO_CYCLE_CORE) || (cached_type == TYPE_SHIFT) || (cached_type == TYPE_LR) || (cached_type == TYPE_SR)))
        {
	  return 4;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW))))) && (((cached_type = get_attr_type (insn)) == TYPE_CC_ARITH) || (cached_type == TYPE_TWO_CYCLE_CORE) || (cached_type == TYPE_SHIFT) || (cached_type == TYPE_LR) || (cached_type == TYPE_SR)))
        {
	  return 6;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))) && (((cached_type = get_attr_type (insn)) == TYPE_MOVE) || (cached_type == TYPE_CMOVE) || (cached_type == TYPE_UNARY) || (cached_type == TYPE_BINARY) || (cached_type == TYPE_COMPARE) || (cached_type == TYPE_MISC)))
        {
	  return 1;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))) && (((cached_type = get_attr_type (insn)) == TYPE_MOVE) || (cached_type == TYPE_CMOVE) || (cached_type == TYPE_UNARY) || (cached_type == TYPE_BINARY) || (cached_type == TYPE_COMPARE) || (cached_type == TYPE_MISC)))
        {
	  return 4;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_DIV_REM))
        {
	  return 13 /* 0xd */;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)))) && (((cached_type = get_attr_type (insn)) == TYPE_MUL16_EM) || (cached_type == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 7;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)))) && (
#line 662 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))) && (((cached_type = get_attr_type (insn)) == TYPE_MUL16_EM) || (cached_type == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 8;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_FPU))
        {
	  return 8;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_FPU_FUSE))
        {
	  return 12 /* 0xc */;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_FPU_SDIV))
        {
	  return 20 /* 0x14 */;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_FPU_DDIV))
        {
	  return 34 /* 0x22 */;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 650 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 652 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 654 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 656 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 658 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 659 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 661 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 662 "../../gcc-13.2.1-20230728/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_FPU_CVT))
        {
	  return 5;
        }
      else if ((
#line 27 "../../gcc-13.2.1-20230728/gcc/config/arc/fpx.md"
(TARGET_SPFP_COMPACT_SET)) && ((cached_type = get_attr_type (insn)) == TYPE_SPFP))
        {
	  return 3;
        }
      else if ((
#line 32 "../../gcc-13.2.1-20230728/gcc/config/arc/fpx.md"
(TARGET_SPFP_FAST_SET)) && ((cached_type = get_attr_type (insn)) == TYPE_SPFP))
        {
	  return 6;
        }
      else if ((
#line 37 "../../gcc-13.2.1-20230728/gcc/config/arc/fpx.md"
(TARGET_DPFP_COMPACT_SET)) && ((cached_type = get_attr_type (insn)) == TYPE_DPFP_MULT))
        {
	  return 7;
        }
      else if ((
#line 37 "../../gcc-13.2.1-20230728/gcc/config/arc/fpx.md"
(TARGET_DPFP_COMPACT_SET)) && ((cached_type = get_attr_type (insn)) == TYPE_DPFP_ADDSUB))
        {
	  return 5;
        }
      else if ((
#line 47 "../../gcc-13.2.1-20230728/gcc/config/arc/fpx.md"
(TARGET_DPFP_FAST_SET)) && (((cached_type = get_attr_type (insn)) == TYPE_DPFP_MULT) || (cached_type == TYPE_DPFP_ADDSUB)))
        {
	  return 5;
        }
      else if (((cached_type = get_attr_type (insn)) == TYPE_SIMD_DMA) || (cached_type == TYPE_SIMD_VSTORE) || (cached_type == TYPE_SIMD_VCONTROL))
        {
	  return 1;
        }
      else if ((cached_type == TYPE_SIMD_VCOMPARE) || (cached_type == TYPE_SIMD_VLOGIC) || (cached_type == TYPE_SIMD_VMOVE_ELSE_ZERO) || (cached_type == TYPE_SIMD_VARITH_1CYCLE))
        {
	  return 2;
        }
      else if ((cached_type == TYPE_SIMD_VALIGN) || (cached_type == TYPE_SIMD_VPERMUTE) || (cached_type == TYPE_SIMD_VPACK) || (cached_type == TYPE_SIMD_VARITH_2CYCLE))
        {
	  return 3;
        }
      else if ((cached_type == TYPE_SIMD_VALIGN_WITH_ACC) || (cached_type == TYPE_SIMD_VPACK_WITH_ACC) || (cached_type == TYPE_SIMD_VLOGIC_WITH_ACC) || (cached_type == TYPE_SIMD_VLOAD128) || (cached_type == TYPE_SIMD_VMOVE_WITH_ACC) || (cached_type == TYPE_SIMD_VSPECIAL_3CYCLE) || (cached_type == TYPE_SIMD_VARITH_WITH_ACC))
        {
	  return 4;
        }
      else if ((cached_type == TYPE_SIMD_VLOAD) || (cached_type == TYPE_SIMD_VMOVE) || (cached_type == TYPE_SIMD_VSPECIAL_4CYCLE))
        {
	  return 5;
        }
      else
        {
	  return 0;
        }

    }
}

