/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../gcc-13.2.1-20230728/gcc/config/bfin/bfin.md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "emit-rtl.h"
#include "tm-constrs.h"
#include "target.h"

bool
pos_scale_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 24 "../../gcc-13.2.1-20230728/gcc/config/bfin/predicates.md"
(INTVAL (op) == 1 || INTVAL (op) == 2));
}

bool
scale_by_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 29 "../../gcc-13.2.1-20230728/gcc/config/bfin/predicates.md"
(INTVAL (op) == 2 || INTVAL (op) == 4));
}

bool
highbits_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 37 "../../gcc-13.2.1-20230728/gcc/config/bfin/predicates.md"
(log2constp (-INTVAL (op)) && !satisfies_constraint_Ks7 (op)));
}

bool
rhs_andsi3_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) || (((GET_CODE (op) == CONST_INT) && (
#line 44 "../../gcc-13.2.1-20230728/gcc/config/bfin/predicates.md"
(log2constp (~INTVAL (op)) || INTVAL (op) == 255 || INTVAL (op) == 65535))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode)));
}

bool
regorlog2_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) || (((GET_CODE (op) == CONST_INT) && (
#line 51 "../../gcc-13.2.1-20230728/gcc/config/bfin/predicates.md"
(log2constp (INTVAL (op))))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode)));
}

bool
reg_or_const_int_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) || ((GET_CODE (op) == CONST_INT) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode)));
}

bool
const01_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 60 "../../gcc-13.2.1-20230728/gcc/config/bfin/predicates.md"
(op == const0_rtx || op == const1_rtx));
}

bool
const1_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 64 "../../gcc-13.2.1-20230728/gcc/config/bfin/predicates.md"
(op == const1_rtx));
}

bool
const3_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 68 "../../gcc-13.2.1-20230728/gcc/config/bfin/predicates.md"
(INTVAL (op) == 3));
}

bool
vec_shift_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (((GET_CODE (op) == CONST_INT) && (
#line 72 "../../gcc-13.2.1-20230728/gcc/config/bfin/predicates.md"
(INTVAL (op) >= -16 && INTVAL (op) < 15))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode))) || (register_operand (op, mode));
}

static inline bool
valid_reg_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 78 "../../gcc-13.2.1-20230728/gcc/config/bfin/predicates.md"
{
  if (GET_CODE (op) == SUBREG)
    op = SUBREG_REG (op);
  if (REGNO (op) < FIRST_PSEUDO_REGISTER)
    return targetm.hard_regno_mode_ok (REGNO (op), mode);
  return 1;
}

bool
valid_reg_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) && (
(valid_reg_operand_1 (op, mode)));
}

bool
d_register_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (
#line 89 "../../gcc-13.2.1-20230728/gcc/config/bfin/predicates.md"
(D_REGNO_P (REGNO (op))))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
p_register_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (
#line 93 "../../gcc-13.2.1-20230728/gcc/config/bfin/predicates.md"
(P_REGNO_P (REGNO (op))))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
dp_register_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (
#line 97 "../../gcc-13.2.1-20230728/gcc/config/bfin/predicates.md"
(D_REGNO_P (REGNO (op)) || P_REGNO_P (REGNO (op))))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
lc_register_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (
#line 102 "../../gcc-13.2.1-20230728/gcc/config/bfin/predicates.md"
(REGNO (op) == REG_LC0 || REGNO (op) == REG_LC1))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
lt_register_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (
#line 107 "../../gcc-13.2.1-20230728/gcc/config/bfin/predicates.md"
(REGNO (op) == REG_LT0 || REGNO (op) == REG_LT1))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
lb_register_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (
#line 112 "../../gcc-13.2.1-20230728/gcc/config/bfin/predicates.md"
(REGNO (op) == REG_LB0 || REGNO (op) == REG_LB1))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
reg_or_7bit_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) || (((GET_CODE (op) == CONST_INT) && (
#line 118 "../../gcc-13.2.1-20230728/gcc/config/bfin/predicates.md"
(satisfies_constraint_Ks7 (op)))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode)));
}

static inline bool
nondp_register_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 123 "../../gcc-13.2.1-20230728/gcc/config/bfin/predicates.md"
{
  unsigned int regno;
  if (GET_CODE (op) == SUBREG)
    op = SUBREG_REG (op);

  regno = REGNO (op);
  return (regno >= FIRST_PSEUDO_REGISTER || !DP_REGNO_P (regno));
}

bool
nondp_register_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) && (
(nondp_register_operand_1 (op, mode)));
}

bool
nondp_reg_or_memory_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (nondp_register_operand (op, mode)) || (memory_operand (op, mode));
}

bool
reg_or_neg7bit_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) || (((GET_CODE (op) == CONST_INT) && (
#line 142 "../../gcc-13.2.1-20230728/gcc/config/bfin/predicates.md"
(satisfies_constraint_KN7 (op)))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode)));
}

static inline bool
fp_plus_const_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 148 "../../gcc-13.2.1-20230728/gcc/config/bfin/predicates.md"
{
  rtx op1, op2;

  op1 = XEXP (op, 0);
  op2 = XEXP (op, 1);
  return (REG_P (op1)
	  && (REGNO (op1) == FRAME_POINTER_REGNUM
	      || REGNO (op1) == STACK_POINTER_REGNUM)
	  && GET_CODE (op2) == CONST_INT);
}

bool
fp_plus_const_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == PLUS) && (
(fp_plus_const_operand_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
symbolic_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == SYMBOL_REF || GET_CODE (op) == LABEL_REF) || ((GET_CODE (op) == CONST) && (
#line 164 "../../gcc-13.2.1-20230728/gcc/config/bfin/predicates.md"
(GET_CODE (XEXP (op,0)) == PLUS
			 && (GET_CODE (XEXP (XEXP (op, 0), 0)) == SYMBOL_REF
			     || GET_CODE (XEXP (XEXP (op, 0), 0)) == LABEL_REF)
			 && GET_CODE (XEXP (XEXP (op, 0), 1)) == CONST_INT)))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

bool
symbolic_or_const_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == CONST_INT || GET_CODE (op) == CONST_DOUBLE) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode))) || (symbolic_operand (op, mode));
}

bool
symbol_ref_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == SYMBOL_REF) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline bool
register_no_elim_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 182 "../../gcc-13.2.1-20230728/gcc/config/bfin/predicates.md"
{
  if (GET_CODE (op) == SUBREG)
    op = SUBREG_REG (op);
  return !(op == arg_pointer_rtx
	   || op == frame_pointer_rtx
	   || (REGNO (op) >= FIRST_PSEUDO_REGISTER
	       && REGNO (op) <= LAST_VIRTUAL_REGISTER));
}

bool
register_no_elim_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) && (
(register_no_elim_operand_1 (op, mode)));
}

bool
bfin_bimode_comparison_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case EQ:
    case NE:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode);
}

bool
bfin_direct_comparison_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case EQ:
    case LT:
    case LE:
    case LEU:
    case LTU:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode);
}

static inline bool
mem_p_address_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 209 "../../gcc-13.2.1-20230728/gcc/config/bfin/predicates.md"
{
  if (effective_address_32bit_p (op, mode))
    return 0;
  op = XEXP (op, 0);
  if (GET_CODE (op) == PLUS || GET_RTX_CLASS (GET_CODE (op)) == RTX_AUTOINC)
    op = XEXP (op, 0);
  gcc_assert (REG_P (op));
  return PREG_P (op) && op != stack_pointer_rtx && op != frame_pointer_rtx;
}

bool
mem_p_address_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == MEM) && (
(mem_p_address_operand_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline bool
mem_spfp_address_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 221 "../../gcc-13.2.1-20230728/gcc/config/bfin/predicates.md"
{
  if (effective_address_32bit_p (op, mode))
    return 0;
  op = XEXP (op, 0);
  if (GET_CODE (op) == PLUS || GET_RTX_CLASS (GET_CODE (op)) == RTX_AUTOINC)
    op = XEXP (op, 0);
  gcc_assert (REG_P (op));
  return op == stack_pointer_rtx || op == frame_pointer_rtx;
}

bool
mem_spfp_address_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == MEM) && (
(mem_spfp_address_operand_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline bool
mem_i_address_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 233 "../../gcc-13.2.1-20230728/gcc/config/bfin/predicates.md"
{
  if (effective_address_32bit_p (op, mode))
    return 0;
  op = XEXP (op, 0);
  if (GET_CODE (op) == PLUS || GET_RTX_CLASS (GET_CODE (op)) == RTX_AUTOINC)
    op = XEXP (op, 0);
  gcc_assert (REG_P (op));
  return IREG_P (op);
}

bool
mem_i_address_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == MEM) && (
(mem_i_address_operand_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
push_multiple_operation (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == PARALLEL) && (
#line 245 "../../gcc-13.2.1-20230728/gcc/config/bfin/predicates.md"
(analyze_push_multiple_operation (op)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
pop_multiple_operation (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == PARALLEL) && (
#line 249 "../../gcc-13.2.1-20230728/gcc/config/bfin/predicates.md"
(analyze_pop_multiple_operation (op)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

enum constraint_num
lookup_constraint_1 (const char *str)
{
  switch (str[0])
    {
    case '<':
      return CONSTRAINT__l;
    case '>':
      return CONSTRAINT__g;
    case 'A':
      return CONSTRAINT_A;
    case 'B':
      return CONSTRAINT_B;
    case 'C':
      return CONSTRAINT_C;
    case 'D':
      return CONSTRAINT_D;
    case 'E':
      return CONSTRAINT_E;
    case 'F':
      return CONSTRAINT_F;
    case 'J':
      return CONSTRAINT_J;
    case 'K':
      if (!strncmp (str + 1, "u3", 2))
        return CONSTRAINT_Ku3;
      if (!strncmp (str + 1, "s4", 2))
        return CONSTRAINT_Ks4;
      if (!strncmp (str + 1, "u4", 2))
        return CONSTRAINT_Ku4;
      if (!strncmp (str + 1, "s5", 2))
        return CONSTRAINT_Ks5;
      if (!strncmp (str + 1, "u5", 2))
        return CONSTRAINT_Ku5;
      if (!strncmp (str + 1, "s7", 2))
        return CONSTRAINT_Ks7;
      if (!strncmp (str + 1, "N7", 2))
        return CONSTRAINT_KN7;
      if (!strncmp (str + 1, "sh", 2))
        return CONSTRAINT_Ksh;
      if (!strncmp (str + 1, "uh", 2))
        return CONSTRAINT_Kuh;
      if (!strncmp (str + 1, "s3", 2))
        return CONSTRAINT_Ks3;
      break;
    case 'L':
      return CONSTRAINT_L;
    case 'M':
      if (str[1] == '2')
        return CONSTRAINT_M2;
      if (str[1] == '1')
        return CONSTRAINT_M1;
      break;
    case 'P':
      if (str[1] == '1')
        return CONSTRAINT_P1;
      if (str[1] == '2')
        return CONSTRAINT_P2;
      if (str[1] == '3')
        return CONSTRAINT_P3;
      if (str[1] == '4')
        return CONSTRAINT_P4;
      if (str[1] == 'A')
        return CONSTRAINT_PA;
      if (str[1] == 'B')
        return CONSTRAINT_PB;
      if (str[1] == '0')
        return CONSTRAINT_P0;
      break;
    case 'Q':
      return CONSTRAINT_Q;
    case 'V':
      return CONSTRAINT_V;
    case 'W':
      return CONSTRAINT_W;
    case 'X':
      return CONSTRAINT_X;
    case 'Y':
      return CONSTRAINT_Y;
    case 'Z':
      return CONSTRAINT_Z;
    case 'a':
      return CONSTRAINT_a;
    case 'b':
      return CONSTRAINT_b;
    case 'c':
      return CONSTRAINT_c;
    case 'd':
      return CONSTRAINT_d;
    case 'e':
      return CONSTRAINT_e;
    case 'f':
      return CONSTRAINT_f;
    case 'i':
      return CONSTRAINT_i;
    case 'k':
      return CONSTRAINT_k;
    case 'm':
      return CONSTRAINT_m;
    case 'n':
      return CONSTRAINT_n;
    case 'o':
      return CONSTRAINT_o;
    case 'p':
      return CONSTRAINT_p;
    case 'q':
      if (str[1] == '1')
        return CONSTRAINT_q1;
      if (str[1] == '2')
        return CONSTRAINT_q2;
      if (str[1] == '3')
        return CONSTRAINT_q3;
      if (str[1] == '4')
        return CONSTRAINT_q4;
      if (str[1] == '5')
        return CONSTRAINT_q5;
      if (str[1] == '6')
        return CONSTRAINT_q6;
      if (str[1] == '7')
        return CONSTRAINT_q7;
      if (str[1] == 'A')
        return CONSTRAINT_qA;
      if (str[1] == '0')
        return CONSTRAINT_q0;
      break;
    case 'r':
      return CONSTRAINT_r;
    case 's':
      return CONSTRAINT_s;
    case 't':
      return CONSTRAINT_t;
    case 'u':
      return CONSTRAINT_u;
    case 'v':
      return CONSTRAINT_v;
    case 'w':
      return CONSTRAINT_w;
    case 'x':
      return CONSTRAINT_x;
    case 'y':
      return CONSTRAINT_y;
    case 'z':
      return CONSTRAINT_z;
    default: break;
    }
  return CONSTRAINT__UNKNOWN;
}

const unsigned char lookup_constraint_array[] = {
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT__l, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT__g, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_A, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_B, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_C, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_D, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_E, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_F, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_J, (int) UCHAR_MAX),
  UCHAR_MAX,
  MIN ((int) CONSTRAINT_L, (int) UCHAR_MAX),
  UCHAR_MAX,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  UCHAR_MAX,
  MIN ((int) CONSTRAINT_Q, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_V, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_W, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_X, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_Y, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_Z, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_a, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_b, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_c, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_d, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_e, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_f, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_i, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_k, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_m, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_n, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_o, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_p, (int) UCHAR_MAX),
  UCHAR_MAX,
  MIN ((int) CONSTRAINT_r, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_s, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_t, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_u, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_v, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_w, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_x, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_y, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_z, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN
};

enum reg_class
reg_class_for_constraint_1 (enum constraint_num c)
{
  switch (c)
    {
    case CONSTRAINT_r: return GENERAL_REGS;
    case CONSTRAINT_a: return PREGS;
    case CONSTRAINT_d: return DREGS;
    case CONSTRAINT_z: return PREGS_CLOBBERED;
    case CONSTRAINT_D: return EVEN_DREGS;
    case CONSTRAINT_W: return ODD_DREGS;
    case CONSTRAINT_e: return AREGS;
    case CONSTRAINT_A: return EVEN_AREGS;
    case CONSTRAINT_B: return ODD_AREGS;
    case CONSTRAINT_b: return IREGS;
    case CONSTRAINT_v: return BREGS;
    case CONSTRAINT_f: return MREGS;
    case CONSTRAINT_c: return CIRCREGS;
    case CONSTRAINT_C: return CCREGS;
    case CONSTRAINT_t: return LT_REGS;
    case CONSTRAINT_u: return LB_REGS;
    case CONSTRAINT_k: return LC_REGS;
    case CONSTRAINT_x: return MOST_REGS;
    case CONSTRAINT_y: return PROLOGUE_REGS;
    case CONSTRAINT_w: return NON_A_CC_REGS;
    case CONSTRAINT_Z: return FDPIC_REGS;
    case CONSTRAINT_Y: return FDPIC_FPTR_REGS;
    case CONSTRAINT_q0: return D0REGS;
    case CONSTRAINT_q1: return D1REGS;
    case CONSTRAINT_q2: return D2REGS;
    case CONSTRAINT_q3: return D3REGS;
    case CONSTRAINT_q4: return D4REGS;
    case CONSTRAINT_q5: return D5REGS;
    case CONSTRAINT_q6: return D6REGS;
    case CONSTRAINT_q7: return D7REGS;
    case CONSTRAINT_qA: return P0REGS;
    default: break;
    }
  return NO_REGS;
}

bool (*constraint_satisfied_p_array[]) (rtx) = {
  satisfies_constraint_J,
  satisfies_constraint_Ks3,
  satisfies_constraint_Ku3,
  satisfies_constraint_Ks4,
  satisfies_constraint_Ku4,
  satisfies_constraint_Ks5,
  satisfies_constraint_Ku5,
  satisfies_constraint_Ks7,
  satisfies_constraint_KN7,
  satisfies_constraint_Ksh,
  satisfies_constraint_Kuh,
  satisfies_constraint_L,
  satisfies_constraint_M1,
  satisfies_constraint_M2,
  satisfies_constraint_P0,
  satisfies_constraint_P1,
  satisfies_constraint_P2,
  satisfies_constraint_P3,
  satisfies_constraint_P4,
  satisfies_constraint_PA,
  satisfies_constraint_PB,
  satisfies_constraint_m,
  satisfies_constraint_o,
  satisfies_constraint_p,
  satisfies_constraint_Q,
  satisfies_constraint_V,
  satisfies_constraint__l,
  satisfies_constraint__g,
  satisfies_constraint_i,
  satisfies_constraint_s,
  satisfies_constraint_n,
  satisfies_constraint_E,
  satisfies_constraint_F,
  satisfies_constraint_X
};

bool
insn_const_int_ok_for_constraint (HOST_WIDE_INT ival, enum constraint_num c)
{
  switch (c)
    {
    case CONSTRAINT_J:
      return 
#line 117 "../../gcc-13.2.1-20230728/gcc/config/bfin/constraints.md"
(log2constp (ival));

    case CONSTRAINT_Ks3:
      return 
#line 122 "../../gcc-13.2.1-20230728/gcc/config/bfin/constraints.md"
(ival >= -4 && ival <= 3);

    case CONSTRAINT_Ku3:
      return 
#line 127 "../../gcc-13.2.1-20230728/gcc/config/bfin/constraints.md"
(ival >= 0 && ival <= 7);

    case CONSTRAINT_Ks4:
      return 
#line 132 "../../gcc-13.2.1-20230728/gcc/config/bfin/constraints.md"
(ival >= -8 && ival <= 7);

    case CONSTRAINT_Ku4:
      return 
#line 137 "../../gcc-13.2.1-20230728/gcc/config/bfin/constraints.md"
(ival >= 0 && ival <= 15);

    case CONSTRAINT_Ks5:
      return 
#line 142 "../../gcc-13.2.1-20230728/gcc/config/bfin/constraints.md"
(ival >= -16 && ival <= 15);

    case CONSTRAINT_Ku5:
      return 
#line 147 "../../gcc-13.2.1-20230728/gcc/config/bfin/constraints.md"
(ival >= 0 && ival <= 31);

    case CONSTRAINT_Ks7:
      return 
#line 152 "../../gcc-13.2.1-20230728/gcc/config/bfin/constraints.md"
(ival >= -64 && ival <= 63);

    case CONSTRAINT_KN7:
      return 
#line 157 "../../gcc-13.2.1-20230728/gcc/config/bfin/constraints.md"
(ival >= -63 && ival <= 64);

    case CONSTRAINT_Ksh:
      return 
#line 162 "../../gcc-13.2.1-20230728/gcc/config/bfin/constraints.md"
(ival >= -32768 && ival <= 32767);

    case CONSTRAINT_Kuh:
      return 
#line 167 "../../gcc-13.2.1-20230728/gcc/config/bfin/constraints.md"
(ival >= 0 && ival <= 65535);

    case CONSTRAINT_L:
      return 
#line 172 "../../gcc-13.2.1-20230728/gcc/config/bfin/constraints.md"
(log2constp (~ival));

    case CONSTRAINT_M1:
      return 
#line 177 "../../gcc-13.2.1-20230728/gcc/config/bfin/constraints.md"
(ival == 255);

    case CONSTRAINT_M2:
      return 
#line 182 "../../gcc-13.2.1-20230728/gcc/config/bfin/constraints.md"
(ival == 65535);

    case CONSTRAINT_P0:
      return 
#line 187 "../../gcc-13.2.1-20230728/gcc/config/bfin/constraints.md"
(ival == 0);

    case CONSTRAINT_P1:
      return 
#line 192 "../../gcc-13.2.1-20230728/gcc/config/bfin/constraints.md"
(ival == 1);

    case CONSTRAINT_P2:
      return 
#line 197 "../../gcc-13.2.1-20230728/gcc/config/bfin/constraints.md"
(ival == 2);

    case CONSTRAINT_P3:
      return 
#line 202 "../../gcc-13.2.1-20230728/gcc/config/bfin/constraints.md"
(ival == 3);

    case CONSTRAINT_P4:
      return 
#line 207 "../../gcc-13.2.1-20230728/gcc/config/bfin/constraints.md"
(ival == 4);

    case CONSTRAINT_PA:
      return 
#line 212 "../../gcc-13.2.1-20230728/gcc/config/bfin/constraints.md"
(ival != MACFLAG_M && ival != MACFLAG_IS_M);

    case CONSTRAINT_PB:
      return 
#line 217 "../../gcc-13.2.1-20230728/gcc/config/bfin/constraints.md"
(ival == MACFLAG_M || ival == MACFLAG_IS_M);

    default: break;
    }
  return false;
}

