/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../gcc-13.2.1-20230728/gcc/config/pa/pa.md'.  */

#ifndef GCC_TM_CONSTRS_H
#define GCC_TM_CONSTRS_H

static inline bool
satisfies_constraint_m (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 26 "../../gcc-13.2.1-20230728/gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op))));
}
static inline bool
satisfies_constraint_o (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 32 "../../gcc-13.2.1-20230728/gcc/common.md"
(offsettable_nonstrict_memref_p (op)));
}
static inline bool
satisfies_constraint_V (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 41 "../../gcc-13.2.1-20230728/gcc/common.md"
(memory_address_addr_space_p (GET_MODE (op), XEXP (op, 0),
						 MEM_ADDR_SPACE (op)))) && (!(
#line 43 "../../gcc-13.2.1-20230728/gcc/common.md"
(offsettable_nonstrict_memref_p (op)))));
}
static inline bool
satisfies_constraint__l (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 50 "../../gcc-13.2.1-20230728/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_DEC)) || (
#line 51 "../../gcc-13.2.1-20230728/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_DEC)));
}
static inline bool
satisfies_constraint__g (rtx op)
{
  return (GET_CODE (op) == MEM) && ((
#line 57 "../../gcc-13.2.1-20230728/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == PRE_INC)) || (
#line 58 "../../gcc-13.2.1-20230728/gcc/common.md"
(GET_CODE (XEXP (op, 0)) == POST_INC)));
}
static inline bool
satisfies_constraint_p (rtx ARG_UNUSED (op))
{
  return 
#line 62 "../../gcc-13.2.1-20230728/gcc/common.md"
(address_operand (op, VOIDmode));
}
static inline bool
satisfies_constraint_i (rtx op)
{
  return (
#line 66 "../../gcc-13.2.1-20230728/gcc/common.md"
(CONSTANT_P (op))) && (
#line 67 "../../gcc-13.2.1-20230728/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_s (rtx op)
{
  return (
#line 71 "../../gcc-13.2.1-20230728/gcc/common.md"
(CONSTANT_P (op))) && ((
#line 72 "../../gcc-13.2.1-20230728/gcc/common.md"
(!CONST_SCALAR_INT_P (op))) && (
#line 73 "../../gcc-13.2.1-20230728/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op))));
}
static inline bool
satisfies_constraint_n (rtx op)
{
  return (
#line 77 "../../gcc-13.2.1-20230728/gcc/common.md"
(CONST_SCALAR_INT_P (op))) && (
#line 78 "../../gcc-13.2.1-20230728/gcc/common.md"
(!flag_pic || LEGITIMATE_PIC_OPERAND_P (op)));
}
static inline bool
satisfies_constraint_E (rtx op)
{
  return (
#line 82 "../../gcc-13.2.1-20230728/gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 83 "../../gcc-13.2.1-20230728/gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_F (rtx op)
{
  return (
#line 89 "../../gcc-13.2.1-20230728/gcc/common.md"
(CONST_DOUBLE_AS_FLOAT_P (op))) || (
#line 90 "../../gcc-13.2.1-20230728/gcc/common.md"
(GET_CODE (op) == CONST_VECTOR
		    && GET_MODE_CLASS (GET_MODE (op)) == MODE_VECTOR_FLOAT));
}
static inline bool
satisfies_constraint_X (rtx ARG_UNUSED (op))
{
  return 
#line 95 "../../gcc-13.2.1-20230728/gcc/common.md"
(true);
}
static inline bool
satisfies_constraint_I (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 48 "../../gcc-13.2.1-20230728/gcc/config/pa/constraints.md"
(VAL_11_BITS_P (ival)));
}
static inline bool
satisfies_constraint_J (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 53 "../../gcc-13.2.1-20230728/gcc/config/pa/constraints.md"
(VAL_14_BITS_P (ival)));
}
static inline bool
satisfies_constraint_K (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 58 "../../gcc-13.2.1-20230728/gcc/config/pa/constraints.md"
(pa_zdepi_cint_p (ival)));
}
static inline bool
satisfies_constraint_L (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 63 "../../gcc-13.2.1-20230728/gcc/config/pa/constraints.md"
(VAL_5_BITS_P (ival)));
}
static inline bool
satisfies_constraint_M (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 68 "../../gcc-13.2.1-20230728/gcc/config/pa/constraints.md"
(ival == 0));
}
static inline bool
satisfies_constraint_N (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 73 "../../gcc-13.2.1-20230728/gcc/config/pa/constraints.md"
(pa_ldil_cint_p (ival)));
}
static inline bool
satisfies_constraint_O (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 78 "../../gcc-13.2.1-20230728/gcc/config/pa/constraints.md"
((ival & (ival + 1)) == 0));
}
static inline bool
satisfies_constraint_P (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 84 "../../gcc-13.2.1-20230728/gcc/config/pa/constraints.md"
(pa_and_mask_p (ival)));
}
static inline bool
satisfies_constraint_S (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 89 "../../gcc-13.2.1-20230728/gcc/config/pa/constraints.md"
(ival == 31));
}
static inline bool
satisfies_constraint_U (rtx op)
{
  HOST_WIDE_INT ival = 0;
  if (CONST_INT_P (op))
    ival = INTVAL (op);
  return (GET_CODE (op) == CONST_INT) && (
#line 94 "../../gcc-13.2.1-20230728/gcc/config/pa/constraints.md"
(ival == 63));
}
static inline bool
satisfies_constraint_G (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return (GET_CODE (op) == CONST_DOUBLE) && (
#line 100 "../../gcc-13.2.1-20230728/gcc/config/pa/constraints.md"
(GET_MODE_CLASS (mode) == MODE_FLOAT
		    && op == CONST0_RTX (mode)));
}
static inline bool
satisfies_constraint_A (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 107 "../../gcc-13.2.1-20230728/gcc/config/pa/constraints.md"
(IS_LO_SUM_DLT_ADDR_P (XEXP (op, 0))));
}
static inline bool
satisfies_constraint_Q (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return 
#line 117 "../../gcc-13.2.1-20230728/gcc/config/pa/constraints.md"
(integer_store_memory_operand (op, mode));
}
static inline bool
satisfies_constraint_R (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 123 "../../gcc-13.2.1-20230728/gcc/config/pa/constraints.md"
(IS_INDEX_ADDR_P (XEXP (op, 0))));
}
static inline bool
satisfies_constraint_T (rtx op)
{
  machine_mode mode = GET_MODE (op);
  return 
#line 127 "../../gcc-13.2.1-20230728/gcc/config/pa/constraints.md"
(floating_point_store_memory_operand (op, mode));
}
static inline bool
satisfies_constraint_W (rtx op)
{
  return (GET_CODE (op) == MEM) && (
#line 134 "../../gcc-13.2.1-20230728/gcc/config/pa/constraints.md"
(REG_P (XEXP (op, 0))
		    && REG_OK_FOR_BASE_P (XEXP (op, 0))));
}
#endif /* tm-constrs.h */
