/* Generated automatically by the program `genextract'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "diagnostic-core.h"

/* This variable is used as the "location" of any missing operand
   whose numbers are skipped by a given pattern.  */
static rtx junk ATTRIBUTE_UNUSED;

void
insn_extract (rtx_insn *insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED; /* only for peepholes */

  if (flag_checking)
    {
      memset (ro, 0xab, sizeof (*ro) * MAX_RECOG_OPERANDS);
      memset (ro_loc, 0xab, sizeof (*ro_loc) * MAX_RECOG_OPERANDS);
    }

  switch (INSN_CODE (insn))
    {
    default:
      /* Control reaches here if insn_extract has been called with an
         unrecognizable insn (code -1), or an insn whose INSN_CODE
         corresponds to a DEFINE_EXPAND in the machine description;
         either way, a bug.  */
      if (INSN_CODE (insn) < 0)
        fatal_insn ("unrecognizable insn:", insn);
      else
        fatal_insn ("insn with invalid code number:", insn);

    case 432:  /* atomic_cas_value_nand_7_di */
    case 431:  /* atomic_cas_value_nand_7_si */
    case 430:  /* atomic_cas_value_or_7_di */
    case 429:  /* atomic_cas_value_or_7_si */
    case 428:  /* atomic_cas_value_xor_7_di */
    case 427:  /* atomic_cas_value_xor_7_si */
    case 426:  /* atomic_cas_value_and_7_di */
    case 425:  /* atomic_cas_value_and_7_si */
    case 424:  /* atomic_cas_value_sub_7_di */
    case 423:  /* atomic_cas_value_sub_7_si */
    case 422:  /* atomic_cas_value_add_7_di */
    case 421:  /* atomic_cas_value_add_7_si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2));
      ro[5] = *(ro_loc[5] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 3));
      ro[6] = *(ro_loc[6] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 4));
      ro[7] = *(ro_loc[7] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[8] = *(ro_loc[8] = &XEXP (XVECEXP (pat, 0, 3), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 434:  /* atomic_cas_value_exchange_7_di */
    case 433:  /* atomic_cas_value_exchange_7_si */
    case 420:  /* atomic_cas_value_cmp_and_7_di */
    case 419:  /* atomic_cas_value_cmp_and_7_si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2));
      ro[5] = *(ro_loc[5] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 3));
      ro[6] = *(ro_loc[6] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 4));
      ro[7] = *(ro_loc[7] = &XEXP (XVECEXP (pat, 0, 2), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 418:  /* atomic_cas_value_strongdi */
    case 417:  /* atomic_cas_value_strongsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2));
      ro[5] = *(ro_loc[5] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 3));
      ro[6] = *(ro_loc[6] = &XEXP (XVECEXP (pat, 0, 2), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 416:  /* atomic_exchangedi */
    case 415:  /* atomic_exchangesi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 414:  /* atomic_fetch_anddi */
    case 413:  /* atomic_fetch_xordi */
    case 412:  /* atomic_fetch_ordi */
    case 411:  /* atomic_fetch_adddi */
    case 410:  /* atomic_fetch_andsi */
    case 409:  /* atomic_fetch_xorsi */
    case 408:  /* atomic_fetch_orsi */
    case 407:  /* atomic_fetch_addsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 406:  /* atomic_anddi */
    case 405:  /* atomic_xordi */
    case 404:  /* atomic_ordi */
    case 403:  /* atomic_adddi */
    case 402:  /* atomic_andsi */
    case 401:  /* atomic_xorsi */
    case 400:  /* atomic_orsi */
    case 399:  /* atomic_addsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0);
      recog_data.dup_num[0] = 0;
      break;

    case 396:  /* mem_thread_fence_1 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (pat, 0, 1));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0);
      recog_data.dup_num[0] = 0;
      break;

    case 387:  /* *join2_loadhi */
    case 386:  /* *join2_loadhi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0));
      break;

    case 385:  /* *join2_load_storedf */
    case 384:  /* *join2_load_storesf */
    case 383:  /* *join2_load_storesi */
    case 382:  /* *join2_load_storehi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 1));
      break;

    case 381:  /* stack_tiedi */
    case 380:  /* stack_tiesi */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 370:  /* bytepick_w_3_extend */
    case 369:  /* bytepick_w_2_extend */
    case 368:  /* bytepick_w_1_extend */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      break;

    case 359:  /* prefetch */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 2));
      break;

    case 355:  /* call_value_internal_1di */
    case 354:  /* call_value_internal_1si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 353:  /* call_value_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 352:  /* call_internal_1di */
    case 351:  /* call_internal_1si */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 350:  /* call_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 358:  /* call_value_multiple_internal_1di */
    case 357:  /* call_value_multiple_internal_1si */
    case 349:  /* sibcall_value_multiple_internal_1di */
    case 348:  /* sibcall_value_multiple_internal_1si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0, 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0, 1);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0, 0);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[2] = 3;
      break;

    case 356:  /* call_value_multiple_internal */
    case 347:  /* sibcall_value_multiple_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 346:  /* sibcall_value_internal_1di */
    case 345:  /* sibcall_value_internal_1si */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 343:  /* sibcall_internal_1di */
    case 342:  /* sibcall_internal_1si */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 0), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 1));
      break;

    case 341:  /* sibcall_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 340:  /* eh_set_ra_di */
    case 339:  /* eh_set_ra_si */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 337:  /* simple_return_internal */
    case 336:  /* return_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 333:  /* probe_stack_rangedi */
    case 332:  /* probe_stack_rangesi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (pat, 1), 0, 2));
      break;

    case 330:  /* tablejumpdi */
    case 329:  /* tablejumpsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      break;

    case 328:  /* indirect_jumpdi */
    case 327:  /* indirect_jumpsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      break;

    case 326:  /* *jump_pic */
    case 325:  /* *jump_absolute */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 266:  /* *branch_equalitydi_inverted */
    case 265:  /* *branch_equalitysi_inverted */
    case 262:  /* *branch_orderdi_inverted */
    case 261:  /* *branch_ordersi_inverted */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 264:  /* branch_equalitydi */
    case 263:  /* branch_equalitysi */
    case 260:  /* *branch_orderdi */
    case 259:  /* *branch_ordersi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 258:  /* *branch_fp_inverted_FCCmode */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 257:  /* *branch_fp_FCCmode */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 248:  /* bstrpick_alsl_paired */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      break;

    case 233:  /* loongarch_lddir_d */
    case 232:  /* loongarch_lddir_w */
    case 231:  /* loongarch_cacop_d */
    case 230:  /* loongarch_cacop_w */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 2));
      break;

    case 235:  /* loongarch_ldpte_d */
    case 234:  /* loongarch_ldpte_w */
    case 229:  /* loongarch_iocsrwr_d */
    case 228:  /* loongarch_iocsrwr_w */
    case 227:  /* loongarch_iocsrwr_h */
    case 226:  /* loongarch_iocsrwr_b */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 1));
      break;

    case 221:  /* loongarch_csrxchg_d */
    case 220:  /* loongarch_csrxchg_w */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 2));
      break;

    case 219:  /* loongarch_csrwr_d */
    case 218:  /* loongarch_csrwr_w */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      break;

    case 225:  /* loongarch_iocsrrd_d */
    case 224:  /* loongarch_iocsrrd_w */
    case 223:  /* loongarch_iocsrrd_h */
    case 222:  /* loongarch_iocsrrd_b */
    case 217:  /* loongarch_csrrd_d */
    case 216:  /* loongarch_csrrd_w */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      break;

    case 362:  /* loongarch_movgr2fcsr */
    case 215:  /* loongarch_asrtgt_d */
    case 214:  /* loongarch_asrtle_d */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (pat, 0, 1));
      break;

    case 213:  /* loongarch_break */
    case 212:  /* loongarch_syscall */
    case 210:  /* loongarch_dbar */
    case 209:  /* loongarch_ibar */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      break;

    case 163:  /* ld_from_gotdi */
    case 162:  /* ld_from_gotsi */
    case 161:  /* tls_lowdi */
    case 160:  /* tls_lowsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0), 1));
      break;

    case 250:  /* alsldi3 */
    case 249:  /* alslsi3 */
    case 247:  /* zero_extend_ashift */
    case 157:  /* lu52i_d */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 156:  /* lu32i_d */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 145:  /* movfcc */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      break;

    case 144:  /* *movdf_softfloat */
    case 143:  /* *movdf_hardfloat */
    case 142:  /* *movsf_softfloat */
    case 141:  /* *movsf_hardfloat */
    case 140:  /* *movqi_internal */
    case 139:  /* *movhi_internal */
    case 138:  /* *movsi_internal */
    case 137:  /* *movdi_64bit */
    case 136:  /* *movdi_32bit */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 135:  /* *insvdi */
    case 134:  /* *insvsi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 1));
      break;

    case 116:  /* *zero_extendhi_truncqi */
    case 115:  /* *zero_extenddi_trunchi */
    case 114:  /* *zero_extendsi_trunchi */
    case 113:  /* *zero_extenddi_truncqi */
    case 112:  /* *zero_extendsi_truncqi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 344:  /* sibcall_value_internal */
    case 104:  /* iorndi */
    case 103:  /* andndi */
    case 102:  /* iornsi */
    case 101:  /* andnsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 83:  /* sminadf3 */
    case 82:  /* sminasf3 */
    case 81:  /* smaxadf3 */
    case 80:  /* smaxasf3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 1);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (pat, 1), 2);
      recog_data.dup_num[1] = 2;
      break;

    case 79:  /* fmindf3 */
    case 78:  /* fminsf3 */
    case 77:  /* fmaxdf3 */
    case 76:  /* fmaxsf3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0));
      break;

    case 379:  /* bitrev_8b */
    case 378:  /* bitrev_4b */
    case 364:  /* fclass_d */
    case 363:  /* fclass_s */
    case 361:  /* loongarch_movfcsr2gr */
    case 256:  /* revh_d */
    case 255:  /* revb_4h */
    case 254:  /* revb_2h */
    case 211:  /* loongarch_cpucfg */
    case 208:  /* movfrh2grtf */
    case 207:  /* movfrh2grdi */
    case 206:  /* movfrh2grdf */
    case 202:  /* got_load_tls_iedi */
    case 201:  /* got_load_tls_iesi */
    case 200:  /* got_load_tls_ledi */
    case 199:  /* got_load_tls_lesi */
    case 198:  /* got_load_tls_lddi */
    case 197:  /* got_load_tls_ldsi */
    case 196:  /* got_load_tls_gddi */
    case 195:  /* got_load_tls_gdsi */
    case 188:  /* load_lowtf */
    case 187:  /* load_lowdi */
    case 186:  /* load_lowdf */
    case 185:  /* lceildfdi2 */
    case 184:  /* lfloordfdi2 */
    case 183:  /* lrintdfdi2 */
    case 182:  /* lceildfsi2 */
    case 181:  /* lfloordfsi2 */
    case 180:  /* lrintdfsi2 */
    case 179:  /* lceilsfdi2 */
    case 178:  /* lfloorsfdi2 */
    case 177:  /* lrintsfdi2 */
    case 176:  /* lceilsfsi2 */
    case 175:  /* lfloorsfsi2 */
    case 174:  /* lrintsfsi2 */
    case 173:  /* rintdf2 */
    case 172:  /* rintsf2 */
    case 167:  /* pcalau12idi */
    case 166:  /* pcalau12isi */
    case 165:  /* lui_l_hi20di */
    case 164:  /* lui_l_hi20si */
    case 67:  /* logb_non_negativedf2 */
    case 66:  /* logb_non_negativesf2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      break;

    case 398:  /* atomic_storedi */
    case 397:  /* atomic_storesi */
    case 395:  /* loongarch_crcc_w_d_w */
    case 394:  /* loongarch_crcc_w_w_w */
    case 393:  /* loongarch_crcc_w_h_w */
    case 392:  /* loongarch_crcc_w_b_w */
    case 391:  /* loongarch_crc_w_d_w */
    case 390:  /* loongarch_crc_w_w_w */
    case 389:  /* loongarch_crc_w_h_w */
    case 388:  /* loongarch_crc_w_b_w */
    case 205:  /* movgr2frhtf */
    case 204:  /* movgr2frhdi */
    case 203:  /* movgr2frhdf */
    case 194:  /* store_wordtf */
    case 193:  /* store_worddi */
    case 192:  /* store_worddf */
    case 191:  /* load_hightf */
    case 190:  /* load_highdi */
    case 189:  /* load_highdf */
    case 171:  /* lui_h_hi12 */
    case 170:  /* lui_h_lo20 */
    case 169:  /* ori_l_lo12di */
    case 168:  /* ori_l_lo12si */
    case 65:  /* ldexpdf3 */
    case 64:  /* ldexpsf3 */
    case 63:  /* copysigndf3 */
    case 62:  /* copysignsf3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 57:  /* *rsqrtdfa */
    case 56:  /* *rsqrtsfa */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 284:  /* *sgeu_didi */
    case 283:  /* *sge_didi */
    case 282:  /* *sgeu_disi */
    case 281:  /* *sge_disi */
    case 280:  /* *sgeu_sisi */
    case 279:  /* *sge_sisi */
    case 272:  /* *sne_zero_didi */
    case 271:  /* *sne_zero_disi */
    case 270:  /* *sne_zero_sisi */
    case 269:  /* *seq_zero_didi */
    case 268:  /* *seq_zero_disi */
    case 267:  /* *seq_zero_sisi */
    case 253:  /* bswapdi2 */
    case 252:  /* bswapsi2 */
    case 251:  /* bswaphi2 */
    case 131:  /* floatdisf2 */
    case 130:  /* floatsisf2 */
    case 129:  /* floatdidf2 */
    case 128:  /* floatsidf2 */
    case 127:  /* fix_truncdfdi2 */
    case 126:  /* fix_truncdfsi2 */
    case 125:  /* fix_truncsfdi2 */
    case 124:  /* fix_truncsfsi2 */
    case 123:  /* extendsfdf2 */
    case 122:  /* extendqihi2 */
    case 121:  /* extendhidi2 */
    case 120:  /* extendhisi2 */
    case 119:  /* extendqidi2 */
    case 118:  /* extendqisi2 */
    case 117:  /* extendsidi2 */
    case 111:  /* zero_extendqihi2 */
    case 110:  /* zero_extendhidi2 */
    case 109:  /* zero_extendhisi2 */
    case 108:  /* zero_extendqidi2 */
    case 107:  /* zero_extendqisi2 */
    case 106:  /* *zero_extendsidi2_internal */
    case 105:  /* truncdfsf2 */
    case 89:  /* negdf2 */
    case 88:  /* negsf2 */
    case 87:  /* one_cmpldi2 */
    case 86:  /* one_cmplsi2 */
    case 85:  /* negdi2 */
    case 84:  /* negsi2 */
    case 71:  /* ctzdi2 */
    case 70:  /* ctzsi2 */
    case 69:  /* clzdi2 */
    case 68:  /* clzsi2 */
    case 61:  /* absdf2 */
    case 60:  /* abssf2 */
    case 55:  /* sqrtdf2 */
    case 54:  /* sqrtsf2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 53:  /* *fnmadf4 */
    case 52:  /* *fnmasf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 2), 0));
      break;

    case 51:  /* *fnmsdf4 */
    case 50:  /* *fnmssf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 49:  /* *fmsdf4 */
    case 48:  /* *fmssf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 47:  /* *fmadf4 */
    case 46:  /* *fmasf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 2), 0));
      break;

    case 45:  /* fnmsdf4 */
    case 44:  /* fnmssf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 155:  /* *seldf */
    case 154:  /* *selsf */
    case 153:  /* *selnedi_using_di */
    case 152:  /* *seleqdi_using_di */
    case 151:  /* *selnesi_using_di */
    case 150:  /* *seleqsi_using_di */
    case 149:  /* *selnedi_using_si */
    case 148:  /* *seleqdi_using_si */
    case 147:  /* *selnesi_using_si */
    case 146:  /* *seleqsi_using_si */
    case 43:  /* fnmadf4 */
    case 42:  /* fnmasf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 41:  /* fmsdf4 */
    case 40:  /* fmssf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 133:  /* *extzvdi */
    case 132:  /* *extzvsi */
    case 39:  /* fmadf4 */
    case 38:  /* fmasf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 21:  /* umulsi3_highpart */
    case 20:  /* mulsi3_highpart */
    case 19:  /* umuldi3_highpart */
    case 18:  /* muldi3_highpart */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1), 0));
      break;

    case 377:  /* bytepick_d_7 */
    case 376:  /* bytepick_d_6 */
    case 375:  /* bytepick_d_5 */
    case 374:  /* bytepick_d_4 */
    case 373:  /* bytepick_d_3 */
    case 372:  /* bytepick_d_2 */
    case 371:  /* bytepick_d_1 */
    case 367:  /* bytepick_w_3 */
    case 366:  /* bytepick_w_2 */
    case 365:  /* bytepick_w_1 */
    case 100:  /* *nordi3 */
    case 99:  /* *norsi3 */
    case 16:  /* mulsidi3_64bit */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 244:  /* *lshrsi3_extend */
    case 243:  /* *ashrsi3_extend */
    case 242:  /* *ashlsi3_extend */
    case 59:  /* *rsqrtdfb */
    case 58:  /* *rsqrtsfb */
    case 37:  /* umoddi3_fake */
    case 36:  /* moddi3_fake */
    case 35:  /* udivdi3_fake */
    case 34:  /* divdi3_fake */
    case 17:  /* *mulsi3_extended */
    case 11:  /* *subsi3_extended */
    case 6:  /* *addsi3_extended */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 324:  /* sungt_df_using_FCCmode */
    case 323:  /* sunge_df_using_FCCmode */
    case 322:  /* sgt_df_using_FCCmode */
    case 321:  /* sge_df_using_FCCmode */
    case 320:  /* sne_df_using_FCCmode */
    case 319:  /* sltgt_df_using_FCCmode */
    case 318:  /* sordered_df_using_FCCmode */
    case 317:  /* sle_df_using_FCCmode */
    case 316:  /* slt_df_using_FCCmode */
    case 315:  /* seq_df_using_FCCmode */
    case 314:  /* sunle_df_using_FCCmode */
    case 313:  /* sunlt_df_using_FCCmode */
    case 312:  /* suneq_df_using_FCCmode */
    case 311:  /* sunordered_df_using_FCCmode */
    case 310:  /* sungt_sf_using_FCCmode */
    case 309:  /* sunge_sf_using_FCCmode */
    case 308:  /* sgt_sf_using_FCCmode */
    case 307:  /* sge_sf_using_FCCmode */
    case 306:  /* sne_sf_using_FCCmode */
    case 305:  /* sltgt_sf_using_FCCmode */
    case 304:  /* sordered_sf_using_FCCmode */
    case 303:  /* sle_sf_using_FCCmode */
    case 302:  /* slt_sf_using_FCCmode */
    case 301:  /* seq_sf_using_FCCmode */
    case 300:  /* sunle_sf_using_FCCmode */
    case 299:  /* sunlt_sf_using_FCCmode */
    case 298:  /* suneq_sf_using_FCCmode */
    case 297:  /* sunordered_sf_using_FCCmode */
    case 296:  /* *sleu_didi */
    case 295:  /* *sle_didi */
    case 294:  /* *sleu_disi */
    case 293:  /* *sle_disi */
    case 292:  /* *sleu_sisi */
    case 291:  /* *sle_sisi */
    case 290:  /* *sltu_didi */
    case 289:  /* *slt_didi */
    case 288:  /* *sltu_disi */
    case 287:  /* *slt_disi */
    case 286:  /* *sltu_sisi */
    case 285:  /* *slt_sisi */
    case 278:  /* *sgtu_didi */
    case 277:  /* *sgt_didi */
    case 276:  /* *sgtu_disi */
    case 275:  /* *sgt_disi */
    case 274:  /* *sgtu_sisi */
    case 273:  /* *sgt_sisi */
    case 246:  /* rotrdi3 */
    case 245:  /* rotrsi3 */
    case 241:  /* lshrdi3 */
    case 240:  /* ashrdi3 */
    case 239:  /* ashldi3 */
    case 238:  /* lshrsi3 */
    case 237:  /* ashrsi3 */
    case 236:  /* ashlsi3 */
    case 159:  /* *lowdi */
    case 158:  /* *lowsi */
    case 98:  /* *iorhi3 */
    case 97:  /* anddi3_extended */
    case 96:  /* andsi3_extended */
    case 95:  /* xordi3 */
    case 94:  /* iordi3 */
    case 93:  /* anddi3 */
    case 92:  /* xorsi3 */
    case 91:  /* iorsi3 */
    case 90:  /* andsi3 */
    case 75:  /* smindf3 */
    case 74:  /* sminsf3 */
    case 73:  /* smaxdf3 */
    case 72:  /* smaxsf3 */
    case 33:  /* *umoddi3 */
    case 32:  /* *moddi3 */
    case 31:  /* *udivdi3 */
    case 30:  /* *divdi3 */
    case 29:  /* *umodsi3 */
    case 28:  /* *modsi3 */
    case 27:  /* *udivsi3 */
    case 26:  /* *divsi3 */
    case 25:  /* *recipdf3 */
    case 24:  /* *recipsf3 */
    case 23:  /* *divdf3 */
    case 22:  /* *divsf3 */
    case 15:  /* muldi3 */
    case 14:  /* mulsi3 */
    case 13:  /* muldf3 */
    case 12:  /* mulsf3 */
    case 10:  /* subdi3 */
    case 9:  /* subsi3 */
    case 8:  /* subdf3 */
    case 7:  /* subsf3 */
    case 5:  /* adddi3 */
    case 4:  /* addsi3 */
    case 3:  /* adddf3 */
    case 2:  /* addsf3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 360:  /* nop */
    case 338:  /* loongarch_ertn */
    case 335:  /* *simple_return */
    case 334:  /* *return */
    case 331:  /* blockage */
    case 1:  /* trap */
      break;

    }
}
